一台电脑上配置多个JDK的问题

版权声明:本文为博主原创文章,未经博主允许不得转载。 https://blog.csdn.net/qq_33448733/article/details/82718936

       因为工作需要,电脑上安装了几个不同的eclipse,几个不同的JDK。当我们只安装一个eclipse、JDK的时候,好像怎么都行,环境变量不设都似乎并无大碍,可是一旦几个eclipse或是JDK一起来,奇葩问题也就容易出现了。

常见问题一:环境变量里配置的JDK版本和java -version指令查询到的JDK版本不一致

        就比如我之前安装了64位 JDK7,后来又安装了64位JDK8,我将环境变量里的JAVA_HOME的值设置为JDK7的安装路径,但是使用java -version指令查询到的一直都是 java version "1.8.0_111"。

常见问题二:has value ‘1.8’,but '1.7' is required,如图

常见问题三:打开eclipse时,提示eclipse和JDK的版本不一致(如32位的eclipse与64位的JDK),于是打不开eclipse,想切换JDK,就是切不过来

      以上问题都是建立在你知道怎么在一台电脑上配置多个版本的JDK的情况下。也不废话了,先说一个办法一招解决上面的问题:将path中的%JAVA_HOME%\bin;%JAVA_HOME%\jre\bin;放到最前面,如图

     额,因为不想去碰注册表什么的,所以以上方法最为简单了。

配置多个JDK的方法,如图

      我想我也不需要多废什么话了,上图一目了然,配置方法也确实是简单,到时只需将JAVA_HOME配置到path中去就行了。

安装JDK时的一点好习惯

        我们在将JDK安装到某个路径下时,可以先建一个文件夹来存放所有的解压文件。如图所示我安装的是64位的JDK8,我就建了一个JDK864文件夹。然后我在那个文件夹里创建了JDK、JRE两个文件夹。在安装JDK的时候需要选择两次安装路径,第一次就选JDK,第二次就选JRE。如此就将开发与执行所需的环境、工具等文件都区分开了,也便于我们进行别的配置,比如环境变量的配置。就拿上图为例,配置环境变量时,JAVA_HOME的值为”。。。。\JDK864\JDK“。

对所出现问题的一点分析与探讨

      通常我们要知道自己配置了什么版本的JDK,只需cmd召唤出指令窗口,然后输入java -version指令一执行即可。而又通常呢,我们所执行java -version那一级目录下又没有java.exe这个可执行文件,然后系统就会根据环境变量path中配置的路径去找jre,然后返回第一个查询到的jre的版本信息。如图是我的path中的配置,

        图中C:\ProgramData\Oracle\Java\javapath;C:\Windows\system32;这两个路径下都可能包含你所安装的最新版本的java.exe等可执行文件(这几个文件都是JDK安装的时候生成的,奇怪的是,似乎只有最高版本的JDK里的java.exe等执行文件才会保留下来),如下图

   所以你当你将JAVA_HOME配置到path的最后面的时候,系统当然是根据前面的C:\ProgramData\Oracle\Java\javapath;C:\Windows\system32;路径来找到jre了,由是你配置环境变量就不起作用了。

        还有一个奇怪的现象,我没搞明白。不知是否是注册表的缘故,你所安装的最新版本的JDK似乎总有特权。就比如你安装了JDK8,然后你将你安装的JDK7中的上图3个文件放到C:\Windows\system32路径下,然后在此路径下执行java -version,然后就会报错,如图:

        相反,如果C:\Windows\system32路径下的那三个可执行文件是JDK8的,则一切正常。。。。。

       此外,当我们想知道某个JDK安装目录下的JDK是哪个版本,多少位时,就去其目录的bin文件夹下,执行java -version指令,如图(此处查询的是JDK7,而电脑里装着JDK8):

      如果bin下有java.exe可执行文件,那么系统就去会找bin的上一级目录下的jre文件夹,如果没找到jre(就是jre,运行环境,空的文件夹可不行),就会报has value ‘1.8’,but '1.7' is required错误,同样情况下,如果你是在JDK8的安装目录下执行java -version指令,就不会出现错误。。。。

      最后顺带说一句,eclipse使用java写的,而其内有没有jre,所以就需要系统提供一个jre,由此你安装的JDK就会影响到eclipse。比如你安装并配置了64位的JDK,32位的eclipse可能就打不开。好了言尽于此吧,自己也不太了解。

 

  

 

没有更多推荐了,返回首页